package com.jasamedika.medifirst2000.controller;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.RegistrasiPasienOnlineService;
import com.jasamedika.medifirst2000.util.CommonUtil;
import com.jasamedika.medifirst2000.vo.AntrianPasienRegistrasiVO;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.Collection;
import java.util.Map;

import static com.jasamedika.medifirst2000.constants.Constants.MessageInfo.ERROR_MESSAGE;
import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_SUCCESS;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonHttpStatus;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonResponse;
import static org.slf4j.LoggerFactory.getLogger;
import static org.springframework.http.HttpStatus.*;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import static org.springframework.web.bind.annotation.RequestMethod.GET;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

/**
 * Controller class for Registrasi Pasien Business
 * 
 * @author adik
 */
@RestController
@RequestMapping("/registrasi-pasien-online")
@JsonIgnoreProperties(ignoreUnknown = true)
public class RegistrasiPasienOnlineController extends LocaleController<AntrianPasienRegistrasiVO> {

	private static final Logger LOGGER = getLogger(RegistrasiPasienOnlineController.class);

	@Autowired
	private RegistrasiPasienOnlineService<AntrianPasienRegistrasiVO> registrasiPasienOnlineService;

	@RequestMapping(value = "/get-pasien", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> getPasien(@RequestParam(value = "id", required = false) String id) {
		try {
			Map<String, Object> result = registrasiPasienOnlineService.getPasienByNoRec(id);
			return getJsonResponse(result, CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when getPasienByNoRec", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when getPasienByNoRec", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/save-registrasi-pasien-online", method = POST, produces = APPLICATION_JSON_VALUE, consumes = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> saveRegistrasiPasienOnline(HttpServletRequest request) {
		try {
			AntrianPasienRegistrasiVO vo = (AntrianPasienRegistrasiVO) this.getItem2(request,
					new AntrianPasienRegistrasiVO());
			Map<String, Object> result = registrasiPasienOnlineService.saveRegistrasiPasienOnline(vo);
			if (null != result) {
				mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
				BroadcastMessage("DaftarAntrianPerjanjian", result.get("noReservasi").toString());
			}
			return getJsonResponse(result, CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when saveRegistrasiPasienOnline", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when saveRegistrasiPasienOnline", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/confirm-registrasi-online/", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> confirmRegistrasiPelayananPasien(
			@RequestParam(value = "noReservasi", required = false) String noReservasi, HttpServletRequest request) {
		try {
			Map<String, Object> resultPageMap = registrasiPasienOnlineService
					.confirmRegistrasiPasienOnline(noReservasi);
			if (CommonUtil.isNotNullOrEmpty(resultPageMap)) {
				mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
				BroadcastMessage("DaftarAntrian", "");
			}
			return getJsonResponse(resultPageMap, OK, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when confirmRegistrasiPasienOnline", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when confirmRegistrasiPasienOnline", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/confirm-pendaftaran/", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> confirmPendaftaran(
			@RequestParam(value = "noReservasi", required = false) String noReservasi, HttpServletRequest request) {
		try {
			Map<String, Object> resultPageMap = registrasiPasienOnlineService.confirmPendaftaran(noReservasi);
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			BroadcastMessage("DaftarAntrian", "");
			return getJsonResponse(resultPageMap, OK, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when confirmPendaftaran", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when confirmPendaftaran", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/antrian-pasien-list/", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<Collection<AntrianPasienRegistrasiVO>> getAllVOWithQueryString(
			@RequestParam(value = "page", required = false, defaultValue = "1") Integer page,
			@RequestParam(value = "limit", required = false, defaultValue = "10") Integer limit,
			@RequestParam(value = "sort", required = false, defaultValue = "noRec") String sort,
			@RequestParam(value = "dir", required = false, defaultValue = "asc") String dir,
			@RequestParam(value = "ruanganId", required = false) Integer ruanganId,
			@RequestParam(value = "dateStart", required = false) String dateStart,
			@RequestParam(value = "dateEnd", required = false) String dateEnd,
			@RequestParam(value = "noReservasi", required = false) String noReservasi,
			@RequestParam(value = "namaPasien", required = false) String namaPasien) {
		Map<String, Object> resultPageMap = registrasiPasienOnlineService.findAllAntrianPaging(page, limit, sort, dir,
				ruanganId, dateStart, dateEnd, namaPasien, noReservasi);
		return constructListPageResult(resultPageMap);
	}

}
